<template>
    <div style="width: 100%;" class="flex flex-wrap">
        <div class="m-4">
            <el-select v-model="value" style="width: 100%;" multiple filterable remote reserve-keyword @keyup="handleKeyUp"
                placeholder="Select tags. Press enter to set new tag." :remote-method="remoteMethod" :loading="loading">
                <el-option v-for="item in options" :key="item.value" :label="item.label" :value="item.value" />
            </el-select>
        </div>
    </div>
</template>
  
<script lang="ts" setup>
import { ref, watch } from 'vue'
import axios from 'axios';



interface ListItem {
    value: string
    label: string
}

const emit = defineEmits(['tagsSelected']);


const options = ref<ListItem[]>([]);
const value = ref<string[]>([]);
const loading = ref(false);



const remoteMethod = (query: string) => {
    if (query && query.length > 2) {
        loading.value = true;

        // @ts-ignore
        axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/tag`,
            { params: { prefix: query } }).then(({ data }) => {
                console.log(data);
                loading.value = false;
                options.value = data.map(el => { return { label: el.content, value: el.content } })
            }).catch(err => {
                console.error(err);
            });

       
    } else {
        options.value = [];
    }
};

watch(()=>[...options.value], (oldValue,newValue)=>{
    emit('tagsSelected',newValue.map(el=>el.value));
}, {deep: true})


    function handleKeyUp(e) {
        console.log(e.key)

        console.log(e.target.value);
        if (e.key === 'Enter') {
            // @ts-ignore
            axios.post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/tag`,
                { content: e.target.value }).then(({ data }) => {
                    e.key.target.value='';
                    console.log(data);

                }).catch(err => {
                    console.error(err);
                })

        }
    }
</script>